//+--------------------------------------------------------------------------------------+
//|                                                                                      |
//+--------------------------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  Blue//DeepSkyBlue
#property indicator_color2  Red//PaleVioletRed
#property indicator_color3  Red//PaleVioletRed
#property indicator_color4  Blue//DodgerBlue
#property indicator_color5  Red//Magenta
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  3
#property indicator_minimum 0
#property indicator_maximum 0.5
//
//
//
//
//

#import "libSSA.dll"
   void fastSingular(double& sourceArray[],int arraySize, int lag, int numberOfComputationLoops, double& destinationArray[]);
#import

//
//
//
//
//

extern string TimeFrame               = "Current time frame";
extern int    SSAPrice                = PRICE_CLOSE;
extern int    SSALag                  = 25;
extern int    SSANumberOfComputations = 2;
extern int    SSANumberOfBars         = 300;
extern int    FirstBar                = 300; 
extern bool   alertsOn                = true;
extern bool   alertsOnCurrent         = false;
extern bool   alertsMessage           = true;
extern bool   alertsSound             = false;
extern bool   alertsNotify            = false;
extern bool   alertsEmail             = false;
extern string soundFile               = "alert2.wav";
extern bool   Interpolate             = true;

extern bool   MultiColor              = true;
extern bool   ShowArrows              = true;
extern int    arrowSize               = 2;
extern bool   ArrowsOnFirstBar        = true;


//
//
//
//
//

double in[];
double ssaDa[];
double ssaDb[];
double arrowUp[];
double arrowDn[];
double pr[];
double slope[];
double ssaIn[];
double ssaOut[];

//
//
//
//
//

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;

//+--------------------------------------------------------------------------------------+
//|                                                                                      |
//+--------------------------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0,in);
      SetIndexBuffer(1,ssaDa);
      SetIndexBuffer(2,ssaDb);
      SetIndexBuffer(3,arrowUp);   
      SetIndexBuffer(4,arrowDn);  
      SetIndexBuffer(5,pr);
      SetIndexBuffer(6,slope);
      
      if (ShowArrows)
      {
        SetIndexStyle(3,DRAW_ARROW,0,arrowSize); SetIndexArrow(3,233);
        SetIndexStyle(4,DRAW_ARROW,0,arrowSize); SetIndexArrow(4,234);   }
      else
      {
        SetIndexStyle(3,DRAW_NONE);
        SetIndexStyle(4,DRAW_NONE);
      }       
      
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" SSA normalized end-pointed");
   return(0);
}
int deinit(){return(0);}

//+--------------------------------------------------------------------------------------+
//|                                                                                      |
//+--------------------------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,limit,counted_bars = IndicatorCounted();

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
      limit = MathMin(Bars-counted_bars,Bars-1);
      if (returnBars) { in[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
      
   if (calculateValue || timeFrame==Period())
   {
     if (MultiColor && slope[limit]==-1) CleanPoint(limit,ssaDa,ssaDb);
     for(i=limit; i>=0; i--)
     {
        pr[i] = iMA(NULL,0,1,0,MODE_SMA,SSAPrice,i);

        //
        //
        //
        //
        //
      
        if (i<=FirstBar)
        {
           int ssaBars = MathMin(Bars-i,SSANumberOfBars);
           if (ssaBars<SSALag) continue;
              if (ArraySize(ssaIn) != ssaBars)
              {
                 ArrayResize(ssaIn ,ssaBars);
                 ArrayResize(ssaOut,ssaBars);
              }
              ArrayCopy(ssaIn,pr,0,i,ssaBars);
      
          fastSingular(ssaIn,ssaBars,SSALag,SSANumberOfComputations,ssaOut);
          in[i]=ssaOut[0];
          
          ssaDa[i] = EMPTY_VALUE;
          ssaDb[i] = EMPTY_VALUE;
          slope[i] = slope[i+1];

          if (in[i]<in[i+1]) slope[i] = -1;
          if (in[i]>in[i+1]) slope[i] =  1;
          if (MultiColor && slope[i] == -1) PlotPoint(i,ssaDa,ssaDb,in);
          
          //
          //
          //
          //
          //
      
          arrowUp[i] = EMPTY_VALUE;
          arrowDn[i] = EMPTY_VALUE;
          if (slope[i]!= slope[i+1])
          //if ( i>0 && slope[i]!= slope[i+1])
          if (slope[i] == 1)
                arrowUp[i] = in[i] - iATR(NULL,0,20,i)/2.0;
          else  arrowDn[i] = in[i] + iATR(NULL,0,20,i)/2.0;
       }                   
   }
   
   //
   //
   //
   //
   //
      
   if (alertsOn)
   {
     if (alertsOnCurrent)
          int whichBar = 0;
     else     whichBar = 1;
     if (slope[whichBar] != slope[whichBar+1])
     if (slope[whichBar] == 1)
           doAlert("sloping up");
     else  doAlert("sloping down");       
   }        
   SetIndexDrawBegin(0,Bars-FirstBar);  
   SetIndexDrawBegin(1,Bars-FirstBar);
   SetIndexDrawBegin(2,Bars-FirstBar);                  
   return(0); 
   }
   
   //
   //
   //
   //
   //
   
   int shift = -1; if (ArrowsOnFirstBar) shift=1;
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (MultiColor && slope[limit]==-1) CleanPoint(limit,ssaDa,ssaDb);
   for(i=limit; i>=0; i--) 
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      int x = iBarShift(NULL,timeFrame,Time[i+shift]);
         in[i]      = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SSAPrice,SSALag,SSANumberOfComputations,SSANumberOfBars,FirstBar,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,0,y);
         ssaDa[i]   = EMPTY_VALUE;
         ssaDb[i]   = EMPTY_VALUE;
         slope[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SSAPrice,SSALag,SSANumberOfComputations,SSANumberOfBars,FirstBar,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,6,y);
      if(x!=y)
      {
         arrowUp[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SSAPrice,SSALag,SSANumberOfComputations,SSANumberOfBars,FirstBar,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,3,y);
         arrowDn[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SSAPrice,SSALag,SSANumberOfComputations,SSANumberOfBars,FirstBar,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,4,y);
      }
      else
      {
         arrowUp[i] = EMPTY_VALUE;
         arrowDn[i] = EMPTY_VALUE;
      }
         //
         //
         //
         //
         //
                        
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++) in[i+k] = in[i] + (in[i+n] - in[i]) * k/n;          
   }
   SetIndexDrawBegin(0,Bars-FirstBar*timeFrame/Period());
   SetIndexDrawBegin(1,Bars-FirstBar*timeFrame/Period());
   SetIndexDrawBegin(2,Bars-FirstBar*timeFrame/Period());
   for(i=limit; i>=0; i--) if (MultiColor && slope[i] == -1) PlotPoint(i,ssaDa,ssaDb,in); 
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," SSA end-pointed ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," SSA end-pointed "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}
